//
//	Copyright (c) 2010 Nemetschek North America 
//	All Rights Reserved.
//
// Created by Vladislav Stanev

#pragma once

namespace VWFC
{
	namespace PluginSupport
	{
		// ------------------------------------------------------------------------------------------------------
		class CWidgetsEditProvider
		{
		public:
						CWidgetsEditProvider(CodeRefID objectID, TComponentTypeID compType=VectorWorks::Extension::kObjectRootComponentTypeID);
			virtual		~CWidgetsEditProvider();

		public:
			void	AddWidget(Sint32 widgetID, const TXString& paramName);
			void	AddWidget(Sint32 widgetID, const TXString& paramName, const TXString& localizedName);
			void	AddWidget(Sint32 widgetID, EWidgetType widgetType, const TXString& paramName, const TXString& localizedName);
			void	AddWidget(Sint32 widgetID, EWidgetType widgetType, const TXString& localizedName);

			void	AddWidget(Sint32 widgetID, int indent, const TXString& paramName);
			void	AddWidget(Sint32 widgetID, int indent, const TXString& paramName, const TXString& localizedName);
			void	AddWidget(Sint32 widgetID, int indent, EWidgetType widgetType, const TXString& paramName, const TXString& localizedName);
			void	AddWidget(Sint32 widgetID, int indent, EWidgetType widgetType, const TXString& localizedName);

		protected:
			void	SetIndent(Sint32 widgetID, int indent);

		private:
			VCOMPtr<VectorWorks::Extension::IExtendedProps>	fExtProps;
			VectorWorks::Extension::IWidgetsEditProvider*	fWidgetsProvider;
		};
	}
}
