//
//	Copyright (c) 2010 Nemetschek North America 
//	All Rights Reserved.
//
// Created by Vladislav Stanev

#include "StdHeaders.h"

#include "VWFC/PluginSupport/WidgetsEditProvider.h"

using namespace VWFC::PluginSupport;
using namespace VectorWorks::Extension;

// ------------------------------------------------------------------------------------------------------
CWidgetsEditProvider::CWidgetsEditProvider(CodeRefID objectID, TComponentTypeID compType)
	: fExtProps( IID_ExtendedProps )
	, fWidgetsProvider( NULL )
{
	VERIFYN( kVStanev, VCOM_SUCCEEDED( fExtProps->GetObjComponentTypeWidgets( objectID, compType, fWidgetsProvider ) ) );
}

CWidgetsEditProvider::~CWidgetsEditProvider()
{
}

void CWidgetsEditProvider::AddWidget(Sint32 widgetID, const TXString& paramName)
{
	if ( fWidgetsProvider ) {
		fWidgetsProvider->AddWidget( widgetID, paramName );
	}
}

void CWidgetsEditProvider::AddWidget(Sint32 widgetID, const TXString& paramName, const TXString& localizedName)
{
	if ( fWidgetsProvider ) {
		fWidgetsProvider->AddWidget( widgetID, paramName, localizedName );
	}
}

void CWidgetsEditProvider::AddWidget(Sint32 widgetID, EWidgetType widgetType, const TXString& paramName, const TXString& localizedName)
{
	if ( fWidgetsProvider ) {
		fWidgetsProvider->AddWidget( widgetID, widgetType, paramName, localizedName );
	}
}

void CWidgetsEditProvider::AddWidget(Sint32 widgetID, EWidgetType widgetType, const TXString& localizedName)
{
	if ( fWidgetsProvider ) {
		fWidgetsProvider->AddWidget( widgetID, widgetType, localizedName );
	}
}

void CWidgetsEditProvider::AddWidget(Sint32 widgetID, int indent, const TXString& paramName)
{
	this->AddWidget( widgetID, paramName );
	this->SetIndent( widgetID, indent );
}

void CWidgetsEditProvider::AddWidget(Sint32 widgetID, int indent, const TXString& paramName, const TXString& localizedName)
{
	this->AddWidget( widgetID, paramName, localizedName );
	this->SetIndent( widgetID, indent );
}

void CWidgetsEditProvider::AddWidget(Sint32 widgetID, int indent, EWidgetType widgetType, const TXString& paramName, const TXString& localizedName)
{
	this->AddWidget( widgetID, widgetType, paramName, localizedName );
	this->SetIndent( widgetID, indent );
}

void CWidgetsEditProvider::AddWidget(Sint32 widgetID, int indent, EWidgetType widgetType, const TXString& localizedName)
{
	this->AddWidget( widgetID, widgetType, localizedName );
	this->SetIndent( widgetID, indent );
}

void CWidgetsEditProvider::SetIndent(Sint32 widgetID, int indent)
{
	if ( fWidgetsProvider ) {
		fWidgetsProvider->GetWidgetByIDSafe( widgetID ).fWidgetIndentLevel	= indent;
	}
}

